resource "linode_firewall" "cluster-{{ .Param "cluster/profile"}}" {
  label = "cluster-{{ .Param "cluster/profile"}}"
  tags  = ["digitalrebar","cluster-{{ .Param "cluster/profile"}}","{{ .Machine.Name }}"]

{{ if (has "*/*" (.Param "network/firewall-ports")) }}
  # accept all traffic - firewall disabled due to */* in network/fireall-ports
  inbound_policy = "ACCEPT"
{{ else }}
  # drop all traffic except listed in DRP network/fireall-ports
  inbound_policy = "DROP"

{{  range $i, $p := (.ComposeParam "network/firewall-ports" | uniq) }}
{{-    if not (eq "*/*" $p) }}
{{-      $portdef := split "/" $p -}}
  inbound {
    label    = "network-firewall-ports-{{$i}}"
    action   = "ACCEPT"
    protocol = "{{ coalesce $portdef._1 "TCP" | upper }}"
    ports    = "{{$portdef._0}}"
    ipv4     = ["0.0.0.0/0"]
    ipv6     = ["::/0"]
  }
{{     end }}
{{   end }}
{{ end }}

  outbound_policy = "ACCEPT"

{{ if .ParamExists "cluster/machine-types" }}
  # include linodes for all cluster/machine-types: {{ .Param "cluster/machine-types" | toString }}
  linodes = flatten([
{{-  range $t := .Param "cluster/machine-types" }}
    [for i in var.drp_{{$t}}_names : "\${linode_instance.drp_{{$t}}[i].id}"],
{{-  end }}
    []
  ])
{{ else }}
  # cannot define linodes, no cluster/machine-types 
{{ end }}

}